/*
 * BrightnessService.cpp
 *
 *  Created on: Feb 1, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2021 trinity desktop development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include <tqregexp.h>

#include "BrightnessService.h"

BrightnessService::BrightnessService(TQT_DBusConnection &conn)
: DeviceServiceBase(conn)
{
    // TODO Auto-generated constructor stub

}

BrightnessService::~BrightnessService()
{
    // TODO Auto-generated destructor stub
}

/*!
 * Implement virtual methods
 *
 */
bool BrightnessService::CanSetBrightness(const TQString& device, bool& value, TQT_DBusError& error) {

    if (device.find( TQRegExp("^/sys/devices.*/brightness$"),0) == 0 ) {
        value = canSetDeviceValue(device, error);
    } else {
        error = TQT_DBusError::stdInvalidArgs(TQString ("Invalid argument for device: " + device));
    }
    if (error.isValid()) {
        tqDebug(error.message().local8Bit());
        return false;
    }
    return true;
}

bool BrightnessService::SetBrightness(const TQString& device, const TQString& brightness, bool& value, TQT_DBusError& error) {

    if (device.find( TQRegExp("^/sys/devices.*/brightness$"),0) == 0) {
        value = setDeviceValue(device, brightness, error);
    } else {
        error = TQT_DBusError::stdInvalidArgs(TQString ("Invalid argument for device: " + device));
    }
    if (error.isValid()) {
        tqDebug(error.message().local8Bit());
        return false;
    }
    return true;
}

void BrightnessService::handleMethodReply(const TQT_DBusMessage& reply) {
    m_connection->send(reply);
}
