/*
 * CPUGovernorService.h
 *
 *  Created on: Feb 1, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2021 trinity desktop development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef CPUGOVERNORSERVICE_H_
#define CPUGOVERNORSERVICE_H_

#include "interfaces/cpugovernorInterface.h"
#include "DeviceServiceBase.h"

class CPUGovernorService: public org::trinitydesktop::hardwarecontrol::CPUGovernorInterface,
        public DeviceServiceBase
{
public:
    CPUGovernorService(TQT_DBusConnection&);
    virtual ~CPUGovernorService();
protected:
    virtual bool CanSetCPUGovernor(TQ_INT32 cpu, bool& value, TQT_DBusError& error) ;

    virtual bool SetCPUGovernor(TQ_INT32 cpu, const TQString& governor, bool& value, TQT_DBusError& error);

protected: // implement sending replies
    void handleMethodReply(const TQT_DBusMessage& reply);

//
//    virtual void CPUGovernorServiceAsync(int asyncCallId, const TQT_DBusObjectPath& device, const TQString& uuid);
};

#endif /* CPUGOVERNORSERVICE_H_ */
