/*
 * DeviceServiceBase.h
 *
 *  Created on: Feb 1, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2021 trinity desktop development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef DEVICESERVICEBASE_H_
#define DEVICESERVICEBASE_H_

#include <tqstring.h>
#include <tqdbusconnection.h>

class DeviceServiceBase
{
public:
    DeviceServiceBase(TQT_DBusConnection&);
    virtual ~DeviceServiceBase();

protected:
    bool canSetDeviceValue(const TQString& device, TQT_DBusError& error);
    bool setDeviceValue(const TQString& device, const TQString& param, TQT_DBusError& error);

protected: // implement sending replies
    virtual void handleMethodReply(const TQT_DBusMessage& reply) = 0;

protected:
    TQT_DBusConnection *m_connection;
};

#endif /* DEVICESERVICEBASE_H_ */
