/*
 * InputEventsService.h
 *
 *  Created on: Feb 1, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2021 trinity desktop development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef INPUTEVENTSSERVICE_H_
#define INPUTEVENTSSERVICE_H_

#include <tqdbusconnection.h>

#include "interfaces/inputeventsInterface.h"

class InputEventsService: public org::trinitydesktop::hardwarecontrol::InputEventsInterface
{
public:
    InputEventsService(TQT_DBusConnection&);
    virtual ~InputEventsService();
protected:

    TQValueList< TQ_UINT32 > getSwitches(const TQString& device, bool active, TQT_DBusError& error);

    virtual bool GetProvidedSwitches(const TQString& device, TQValueList< TQ_UINT32 >& value, TQT_DBusError& error);

    virtual bool GetActiveSwitches(const TQString& device, TQValueList< TQ_UINT32 >& value, TQT_DBusError& error);

protected: // implement sending replies
    virtual void handleMethodReply(const TQT_DBusMessage& reply);
//
//    virtual void InputEventsServiceAsync(int asyncCallId, const TQT_DBusObjectPath& device, const TQString& uuid);

private:
    TQT_DBusConnection *m_connection;
};

#endif /* INPUTEVENTSSERVICE_H_ */
