/*
 * PowerService.h
 *
 *  Created on: Feb 1, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2021 trinity desktop development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef POWERSERVICE_H_
#define POWERSERVICE_H_

#include "interfaces/powerInterface.h"
#include "DeviceServiceBase.h"

class PowerService: public org::trinitydesktop::hardwarecontrol::PowerInterface,
        public DeviceServiceBase
{
public:
    PowerService(TQT_DBusConnection&);
    virtual ~PowerService();
protected:
    bool canSetPower(TQString state, TQT_DBusError& error);

    bool setPower(TQString state, TQT_DBusError& error);

    bool canSetHibernation(TQString state, TQT_DBusError& error);

    bool setHibernation(TQString state, TQT_DBusError& error);

    virtual bool CanStandby(bool& value, TQT_DBusError& error);

    virtual bool Standby(bool& value, TQT_DBusError& error);

    virtual bool CanFreeze(bool& value, TQT_DBusError& error);

    virtual bool Freeze(bool& value, TQT_DBusError& error);

    virtual bool CanSuspend(bool& value, TQT_DBusError& error);

    virtual bool Suspend(bool& value, TQT_DBusError& error);

    virtual bool CanHibernate(bool& value, TQT_DBusError& error);

    virtual bool Hibernate(bool& value, TQT_DBusError& error);

    virtual bool CanHybridSuspend(bool& value, TQT_DBusError& error);

    virtual bool HybridSuspend(bool& value, TQT_DBusError& error);

    virtual bool CanSetHibernationMethod(bool& value, TQT_DBusError& error);

    virtual bool SetHibernationMethod(const TQString& method, bool& value, TQT_DBusError& error);

protected: // implement sending replies
    void handleMethodReply(const TQT_DBusMessage& reply);
//
//    virtual void PowerServiceAsync(int asyncCallId, const TQT_DBusObjectPath& device, const TQString& uuid);
};

#endif /* POWERSERVICE_H_ */
