/*
 * PropertiesService.h
 *
 *  Created on: Feb 7, 2021
 *      Author: emanoil
 *
 * hardwarecontrol Copyright (C) 2009 hardwarecontrol development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef PROPERTIESSERVICE_H_
#define PROPERTIESSERVICE_H_

#include <tqmap.h>

#include <tqdbusconnection.h>
#include <tqdbusvariant.h>

#include "interfaces/propertiesInterface.h"

class PropertiesService: public org::freedesktop::DBus::PropertiesInterface
{
public:
    PropertiesService(TQT_DBusConnection&);
    virtual ~PropertiesService();

protected: // implement sending signals
    virtual bool handleSignalSend(const TQT_DBusMessage& reply);
    virtual TQString objectPath() const;

protected:
    virtual bool Get(const TQString& interface, const TQString& name, TQT_DBusVariant& value, TQT_DBusError& error);

    virtual bool Set(const TQString& interface, const TQString& name, const TQT_DBusVariant& value, TQT_DBusError& error);

    virtual bool GetAll(const TQString& interface, TQMap< TQString, TQT_DBusVariant >& properties, TQT_DBusError& error);

protected: // implement sending replies
    virtual void handleMethodReply(const TQT_DBusMessage& reply);

private:
    TQT_DBusConnection *m_connection;
};

#endif /* PROPERTIESSERVICE_H_ */
